Ext.data.proxy.Rest
Alternate names
Ext.data.RestProxyHierarchy
Ext.BaseExt.data.proxy.ProxyExt.data.proxy.ServerExt.data.proxy.AjaxExt.data.proxy.RestInherited mixins
Files
The Rest proxy is a specialization of the AjaxProxy which simply maps the four actions (create, read, update and destroy) to RESTful HTTP verbs. For example, let's set up a Model with an inline Rest proxy
Ext.define('User', {
extend: 'Ext.data.Model',
fields: ['id', 'name', 'email'],
proxy: {
type: 'rest',
url : '/users'
}
});
Now we can create a new User instance and save it via the Rest proxy. Doing this will cause the Proxy to send a POST request to '/users':
var user = Ext.create('User', {name: 'Ed Spencer', email: 'ed@sencha.com'});
user.save(); //POST /users
Let's expand this a little and provide a callback for the Ext.data.Model.save call to update the Model once it has been created. We'll assume the creation went successfully and that the server gave this user an ID of 123:
user.save({
success: function(user) {
user.set('name', 'Khan Noonien Singh');
user.save(); //PUT /users/123
}
});
Now that we're no longer creating a new Model instance, the request method is changed to an HTTP PUT, targeting the relevant url for that user. Now let's delete this user, which will use the DELETE method:
user.destroy(); //DELETE /users/123
Finally, when we perform a load of a Model or Store, Rest proxy will use the GET method:
//1. Load via Store
//the Store automatically picks up the Proxy from the User model
var store = Ext.create('Ext.data.Store', {
model: 'User'
});
store.load(); //GET /users
//2. Load directly from the Model
//GET /users/123
Ext.ModelManager.getModel('User').load(123, {
success: function(user) {
console.log(user.getId()); //outputs 123
}
});
Url generation
The Rest proxy is able to automatically generate the urls above based on two configuration options - appendId and format. If appendId is true (it is by default) then Rest proxy will automatically append the ID of the Model instance in question to the configured url, resulting in the '/users/123' that we saw above.
If the request is not for a specific Model instance (e.g. loading a Store), the url is not appended with an id. The Rest proxy will automatically insert a '/' before the ID if one is not already present.
new Ext.data.proxy.Rest({
url: '/users',
appendId: true //default
});
// Collection url: /users
// Instance url : /users/123
The Rest proxy can also optionally append a format string to the end of any generated url:
new Ext.data.proxy.Rest({
url: '/users',
format: 'json'
});
// Collection url: /users.json
// Instance url : /users/123.json
If further customization is needed, simply implement the buildUrl method and add your custom generated url onto the Request object that is passed to buildUrl. See Rest proxy's implementation for an example of how to achieve this.
Note that Rest proxy inherits from AjaxProxy, which already injects all of the sorter, filter, group and paging options into the generated url. See the AjaxProxy docs for more details.
Available since: 4.0.0
Config options
Specific urls to call on CRUD action methods "create", "read", "update" and "destroy". Defaults to:
api: {
create : undefined,
read : undefined,
update : undefined,
destroy : undefined
}
The url is built based upon the action being executed [create|read|update|destroy] using the commensurate api property, or if undefined default to the configured Ext.data.Store.url.
For example:
api: {
create : '/controller/new',
read : '/controller/load',
update : '/controller/update',
destroy : '/controller/destroy_action'
}
If the specific URL for a given CRUD action is undefined, the CRUD action request will be directed to the configured url.
Available since: 4.0.0
True to automatically append the ID of a Model instance when performing a request based on that single instance. See Rest proxy intro docs for more details. Defaults to true.
Defaults to: true
Available since: 4.0.0
True to batch actions of a particular type when synchronizing the store. Defaults to false.
Defaults to: false
Available since: 4.0.0
Overrides: Ext.data.proxy.Proxy.batchActions
Comma-separated ordering 'create', 'update' and 'destroy' actions when batching. Override this to set a different order for the batched CRUD actions to be executed in. Defaults to 'create,update,destroy'.
Defaults to: 'create,update,destroy'
Available since: 4.0.0
The name of the cache param added to the url when using noCache. Defaults to "_dc".
Defaults to: "_dc"
Available since: 4.0.0
The default registered reader type. Defaults to 'json'.
Defaults to: 'json'
Available since: 4.0.0
The default registered writer type. Defaults to 'json'.
Defaults to: 'json'
Available since: 4.0.0
The name of the direction parameter to send in a request. This is only used when simpleSortMode is set to true. Defaults to 'dir'.
Defaults to: 'dir'
Available since: 4.0.0
Extra parameters that will be included on every request. Individual requests with params of the same name will override these params when they are in conflict.
Available since: 4.0.0
The name of the 'filter' parameter to send in a request. Defaults to 'filter'. Set this to undefined if you don't want to send a filter parameter.
Defaults to: 'filter'
Available since: 4.0.0
Optional data format to send to the server when making any request (e.g. 'json'). See the Rest proxy intro docs for full details. Defaults to undefined.
Available since: 4.0.0
The name of the 'group' parameter to send in a request. Defaults to 'group'. Set this to undefined if you don't want to send a group parameter.
Defaults to: 'group'
Available since: 4.0.0
Any headers to add to the Ajax request. Defaults to undefined.
Available since: 4.0.0
The name of the 'limit' parameter to send in a request. Defaults to 'limit'. Set this to undefined if you don't want to send a limit parameter.
Defaults to: 'limit'
Available since: 4.0.0
A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once.
DOM events from Ext JS Components
While some Ext JS Component classes export selected DOM events (e.g. "click", "mouseover" etc), this is usually
only done when extra value can be added. For example the DataView's itemclick event passing the node clicked on. To access DOM events directly from a
child element of a Component, we need to specify the element option to identify the Component property to add a
DOM listener to:
new Ext.panel.Panel({
width: 400,
height: 200,
dockedItems: [{
xtype: 'toolbar'
}],
listeners: {
click: {
element: 'el', //bind to the underlying el property on the panel
fn: function(){ console.log('click el'); }
},
dblclick: {
element: 'body', //bind to the underlying body property on the panel
fn: function(){ console.log('dblclick body'); }
}
}
});
Available since: 1.1.0
The name of the Model to tie to this Proxy. Can be either the string name of the Model, or a reference to the Model constructor. Required.
Available since: 4.0.0
Disable caching by adding a unique parameter name to the request. Set to false to allow caching. Defaults to true.
Defaults to: true
Available since: 4.0.0
The name of the 'page' parameter to send in a request. Defaults to 'page'. Set this to undefined if you don't want to send a page parameter.
Defaults to: 'page'
Available since: 4.0.0
The Ext.data.reader.Reader to use to decode the server's response or data read from client. This can either be a Reader instance, a config object or just a valid Reader type name (e.g. 'json', 'xml').
Available since: 4.0.4
Enabling simpleSortMode in conjunction with remoteSort will only send one sort property and a direction when a remote sort is requested. The directionParam and sortParam will be sent with the property name and either 'ASC' or 'DESC'.
Defaults to: false
Available since: 4.0.0
The name of the 'sort' parameter to send in a request. Defaults to 'sort'. Set this to undefined if you don't want to send a sort parameter.
Defaults to: 'sort'
Available since: 4.0.0
The name of the 'start' parameter to send in a request. Defaults to 'start'. Set this to undefined if you don't want to send a start parameter.
Defaults to: 'start'
Available since: 4.0.0
The number of milliseconds to wait for a response. Defaults to 30000 milliseconds (30 seconds).
Defaults to: 30000
Available since: 4.0.0
The URL from which to request the data object.
The URL from which to request the data object.
Available since: 4.0.0
The Ext.data.writer.Writer to use to encode any request sent to the server or saved to client. This can either be a Writer instance, a config object or just a valid Writer type name (e.g. 'json', 'xml').
Available since: 4.0.4
Properties
Mapping of action name to HTTP request method. These default to RESTful conventions for the 'create', 'read', 'update' and 'destroy' actions (which map to 'POST', 'GET', 'PUT' and 'DELETE' respectively). This object should not be changed except globally via Ext.override - the getMethod function can be overridden instead.
Defaults to: {create: 'POST', read: 'GET', update: 'PUT', destroy: 'DELETE'}
Available since: 4.0.0
Overrides: Ext.data.proxy.Ajax.actionMethods
Defaults to: /^(?:scope|delay|buffer|single|stopEvent|preventDefault|stopPropagation|normalized|args|delegate|element|vertical|horizontal|freezeEvent)$/
Available since: 4.0.0
Get the reference to the current class from which this object was instantiated. Unlike statics,
this.self is scope-dependent and it's meant to be used for dynamic inheritance. See statics
for a detailed comparison
Ext.define('My.Cat', {
statics: {
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
alert(this.self.speciesName); / dependent on 'this'
return this;
},
clone: function() {
return new this.self();
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
}
});
var cat = new My.Cat(); // alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
Available since: 4.0.0
Methods
Instance Methods Note that if this HttpProxy is being used by a Store, then the Store's call to
load will override any specified callb...Note that if this HttpProxy is being used by a Store, then the Store's call to
load will override any specified callback and params options. In this case, use the
Store's events to modify parameters, or react to loading events.
Available since: 1.1.0
Parameters
- config : Object (optional)
Config object.
If an options parameter is passed, the singleton Ext.Ajax object will be used to make the request.
Returns
Overrides: Ext.data.proxy.Proxy.constructor
addEvents( o, [more] )Adds the specified events to the list of events which this Observable may fire. ...Adds the specified events to the list of events which this Observable may fire.
Available since: 1.1.0
Parameters
- o : Object/String
Either an object with event names as properties with a value of true or the first
event name string if multiple event names are being passed as separate parameters. Usage:
this.addEvents({
storeloaded: true,
storecleared: true
});
- more : String... (optional)
Additional event names if multiple event names are being passed as separate
parameters. Usage:
this.addEvents('storeloaded', 'storecleared');
addListener( eventName, fn, [scope], [options] )Appends an event handler to this object. ...Appends an event handler to this object.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to listen for. May also be an object who's property names are
event names.
- fn : Function
The method the event invokes. Will be called with arguments given to
fireEvent plus the options parameter described below.
- scope : Object (optional)
The scope (this reference) in which the handler function is executed. If
omitted, defaults to the object which fired the event.
- options : Object (optional)
An object containing handler configuration.
Note: Unlike in ExtJS 3.x, the options object will also be passed as the last argument to every event handler.
This object may contain any of the following properties:
scope : Object
The scope (this reference) in which the handler function is executed. If omitted, defaults to the object
which fired the event.
delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
buffer : Number
Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of
milliseconds. If the event fires again within that time, the original handler is not invoked, but the new
handler is scheduled in its place.
target : Observable
Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a
child Observable.
element : String
This option is only valid for listeners bound to Components. The name of a Component
property which references an element to add a listener to.
This option is useful during Component construction to add DOM event listeners to elements of
Components which will exist only after the Component is rendered.
For example, to add a click listener to a Panel's body:
new Ext.panel.Panel({
title: 'The title',
listeners: {
click: this.handlePanelClick,
element: 'body'
}
});
Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener.
myPanel.on('hide', this.handleClick, this, {
single: true,
delay: 100
});
Attaching multiple handlers in 1 call
The method also allows for a single argument to be passed which is a config object containing properties which
specify multiple events. For example:
myGridPanel.on({
cellClick: this.onCellClick,
mouseover: this.onMouseOver,
mouseout: this.onMouseOut,
scope: this // Important. Ensure "this" is correct during handler execution
});
One can also specify options for each event handler separately:
myGridPanel.on({
cellClick: {fn: this.onCellClick, scope: this, single: true},
mouseover: {fn: panel.onMouseOver, scope: panel}
});
addManagedListener( item, ename, [fn], [scope], [opt] )Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is
destr...Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is
destroyed.
Available since: 4.0.0
Parameters
- item : Ext.util.Observable/Ext.Element
The item to which to add a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the ename parameter was an event name, this is the handler function.
- scope : Object (optional)
If the ename parameter was an event name, this is the scope (this reference)
in which the handler function is executed.
- opt : Object (optional)
If the ename parameter was an event name, this is the
addListener options.
afterRequest( request, success )Optional callback function which can be used to clean up after a request has been completed. ...Optional callback function which can be used to clean up after a request has been completed.
Available since: 4.0.0
Parameters
- request : Ext.data.Request
The Request object
- success : Boolean
True if the request was successful
Performs a batch of Operations, in the order specified by batchOrder. ...Performs a batch of Operations, in the order specified by batchOrder. Used
internally by Ext.data.Store's sync method. Example usage:
myProxy.batch({
create : [myModel1, myModel2],
update : [myModel3],
destroy: [myModel4, myModel5]
});
Where the myModel* above are Model instances - in this case 1 and 2 are new instances and
have not been saved before, 3 has been saved previously but needs to be updated, and 4 and 5 have already been
saved but should now be destroyed.
Available since: 4.0.0
Parameters
- operations : Object
Object containing the Model instances to act upon, keyed by action name
- listeners : Object (optional)
listeners object passed straight through to the Batch -
see Ext.data.Batch
Returns
- Ext.data.Batch
The newly created Ext.data.Batch object
Creates and returns an Ext.data.Request object based on the options passed by the Store
that this Proxy is attached to. ...Creates and returns an Ext.data.Request object based on the options passed by the Store
that this Proxy is attached to.
Available since: 4.0.0
Parameters
- operation : Ext.data.Operation
The Operation object to execute
Returns
- Ext.data.Request
The request object
buildUrl( request )Specialized version of buildUrl that incorporates the appendId and format options into the
generated url. ...Specialized version of buildUrl that incorporates the appendId and format options into the
generated url. Override this to provide further customizations, but remember to call the superclass buildUrl so
that additional parameters like the cache buster string are appended.
Available since: 4.0.0
Parameters
- request : Object
Overrides: Ext.data.proxy.Server.buildUrl
Call the original method that was previously overridden with override
Ext.define('My.Cat', {
constructor: functi...Call the original method that was previously overridden with override
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
return this;
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
var instance = this.callOverridden();
alert("Meeeeoooowwww");
return instance;
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
Available since: 4.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the arguments object
Returns
- Object
Returns the result after calling the overridden method
Call the parent's overridden method. ...Call the parent's overridden method. For example:
Ext.define('My.own.A', {
constructor: function(test) {
alert(test);
}
});
Ext.define('My.own.B', {
extend: 'My.own.A',
constructor: function(test) {
alert(test);
this.callParent([test + 1]);
}
});
Ext.define('My.own.C', {
extend: 'My.own.B',
constructor: function() {
alert("Going to call parent's overriden constructor...");
this.callParent(arguments);
}
});
var a = new My.own.A(1); // alerts '1'
var b = new My.own.B(1); // alerts '1', then alerts '2'
var c = new My.own.C(2); // alerts "Going to call parent's overriden constructor..."
// alerts '2', then alerts '3'
Available since: 4.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the arguments object
from the current method, for example: this.callParent(arguments)
Returns
- Object
Returns the result from the superclass' method
Removes all listeners for this object including the managed listeners ...Removes all listeners for this object including the managed listeners
Available since: 4.0.0
Removes all managed listeners for this object. ...Removes all managed listeners for this object.
Available since: 4.0.0
continueFireEvent( eventName, args, bubbles )★private create( operation, callback, scope )in a ServerProxy all four CRUD operations are executed in the same manner, so we delegate to doRequest in each case
...in a ServerProxy all four CRUD operations are executed in the same manner, so we delegate to doRequest in each case
Performs the given create operation.
Available since: 4.0.0
Parameters
- operation : Ext.data.Operation
The Operation to perform
- callback : Function
Callback function to be called when the Operation has completed (whether successful or not)
- scope : Object
Scope to execute the callback function in
Overrides: Ext.data.proxy.Proxy.create
TODO: This is currently identical to the JsonPProxy version except for the return function's signature. ...TODO: This is currently identical to the JsonPProxy version except for the return function's signature. There is a lot
of code duplication inside the returned function so we need to find a way to DRY this up.
Available since: 4.0.0
Parameters
- request : Ext.data.Request
The Request object
- operation : Ext.data.Operation
The Operation being executed
- callback : Function
The callback function to be called when the request completes. This is usually the callback
passed to doRequest
- scope : Object
The scope in which to execute the callback function
Returns
- Function
The callback function
destroy( operation, callback, scope )Performs the given destroy operation. ...Performs the given destroy operation.
Available since: 4.0.0
Parameters
- operation : Ext.data.Operation
The Operation to perform
- callback : Function
Callback function to be called when the Operation has completed (whether successful or not)
- scope : Object
Scope to execute the callback function in
Overrides: Ext.data.proxy.Proxy.destroy
doRequest( operation, callback, scope )In ServerProxy subclasses, the create, read, update and destroy methods all
pass through to doRequest. ...In ServerProxy subclasses, the create, read, update and destroy methods all
pass through to doRequest. Each ServerProxy subclass must implement the doRequest method - see Ext.data.proxy.JsonP and Ext.data.proxy.Ajax for examples. This method carries the same signature as
each of the methods that delegate to it.
Available since: 4.0.0
Parameters
- operation : Ext.data.Operation
The Ext.data.Operation object
- callback : Function
The callback function to call when the Operation has completed
- scope : Object
The scope in which to execute the callback
enableBubble( events )Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if
present. ...Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if
present. There is no implementation in the Observable base class.
This is commonly used by Ext.Components to bubble events to owner Containers.
See Ext.Component.getBubbleTarget. The default implementation in Ext.Component returns the
Component's immediate owner. But if a known target is required, this can be overridden to access the
required target more quickly.
Example:
Ext.override(Ext.form.field.Base, {
// Add functionality to Field's initComponent to enable the change event to bubble
initComponent : Ext.Function.createSequence(Ext.form.field.Base.prototype.initComponent, function() {
this.enableBubble('change');
}),
// We know that we want Field's events to bubble directly to the FormPanel.
getBubbleTarget : function() {
if (!this.formPanel) {
this.formPanel = this.findParentByType('form');
}
return this.formPanel;
}
});
var myForm = new Ext.formPanel({
title: 'User Details',
items: [{
...
}],
listeners: {
change: function() {
// Title goes red if form has been modified.
myForm.header.setStyle('color', 'red');
}
}
});
Available since: 3.4.0
Parameters
Encodes the array of Ext.util.Filter objects into a string to be sent in the request url. ...Encodes the array of Ext.util.Filter objects into a string to be sent in the request url. By default,
this simply JSON-encodes the filter data
Available since: 4.0.0
Parameters
- filters : Ext.util.Filter[]
The array of Filter objects
Returns
- String
The encoded filters
Encodes the array of Ext.util.Sorter objects into a string to be sent in the request url. ...Encodes the array of Ext.util.Sorter objects into a string to be sent in the request url. By default,
this simply JSON-encodes the sorter data
Available since: 4.0.0
Parameters
- sorters : Ext.util.Sorter[]
The array of Sorter objects
Returns
- String
The encoded sorters
Template method to allow subclasses to specify how to get the response for the reader. ...Template method to allow subclasses to specify how to get the response for the reader.
Available since: 4.0.0
This is a template method.
a hook into the functionality of this class.
Feel free to override it in child classes.
Parameters
- response : Object
The server response
Returns
- Object
The response data to be used by the reader
Fires the specified event with the passed parameters (minus the event name, plus the options object passed
to addList...Fires the specified event with the passed parameters (minus the event name, plus the options object passed
to addListener).
An event may be set to bubble up an Observable parent hierarchy (See Ext.Component.getBubbleTarget) by
calling enableBubble.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to fire.
- args : Object...
Variable number of parameters are passed to handlers.
Returns
- Boolean
returns false if any of the handlers return false otherwise it returns true.
getBubbleParent( ) : Ext.util.Observable★privateGets the bubbling parent for an Observable ...Gets the bubbling parent for an Observable
Available since: Ext JS 4.0.7
Returns
- Ext.util.Observable
The bubble parent. null is returned if no bubble target exists
Returns the HTTP method name for a given request. ...Returns the HTTP method name for a given request. By default this returns based on a lookup on
actionMethods.
Available since: 4.0.0
Parameters
- request : Ext.data.Request
The request object
Returns
- String
The HTTP method to use (should be one of 'GET', 'POST', 'PUT' or 'DELETE')
getParams( operation )privateCopy any sorters, filters etc into the params so they can be sent over the wire ...Copy any sorters, filters etc into the params so they can be sent over the wire
Available since: 4.0.0
Parameters
- operation : Object
Returns the reader currently attached to this proxy instance ...Returns the reader currently attached to this proxy instance
Available since: 4.0.0
Returns
- Ext.data.reader.Reader
The Reader instance
Get the url for the request taking into account the order of priority,
- The request
- The api
- The url ...Get the url for the request taking into account the order of priority,
- The request
- The api
- The url
Available since: 4.0.0
Parameters
- request : Ext.data.Request
The request
Returns
- String
The url
Returns the writer currently attached to this proxy instance ...Returns the writer currently attached to this proxy instance
Available since: 4.0.0
Returns
- Ext.data.writer.Writer
The Writer instance
Initialize configuration for this class. ...Initialize configuration for this class. a typical example:
Ext.define('My.awesome.Class', {
// The default config
config: {
name: 'Awesome',
isAwesome: true
},
constructor: function(config) {
this.initConfig(config);
return this;
}
});
var awesome = new My.awesome.Class({
name: 'Super Awesome'
});
alert(awesome.getName()); // 'Super Awesome'
Available since: 4.0.0
Parameters
- config : Object
Returns
- Object
mixins The mixin prototypes as key - value pairs
mixin( name, cls )private mon( item, ename, [fn], [scope], [opt] )Shorthand for addManagedListener. ...Shorthand for addManagedListener.
Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is
destroyed.
Available since: 4.0.2
Parameters
- item : Ext.util.Observable/Ext.Element
The item to which to add a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the ename parameter was an event name, this is the handler function.
- scope : Object (optional)
If the ename parameter was an event name, this is the scope (this reference)
in which the handler function is executed.
- opt : Object (optional)
If the ename parameter was an event name, this is the
addListener options.
mun( item, ename, [fn], [scope] )Shorthand for removeManagedListener. ...Shorthand for removeManagedListener.
Removes listeners that were added by the mon method.
Available since: 4.0.2
Parameters
- item : Ext.util.Observable/Ext.Element
The item from which to remove a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the ename parameter was an event name, this is the handler function.
- scope : Object (optional)
If the ename parameter was an event name, this is the scope (this reference)
in which the handler function is executed.
on( eventName, fn, [scope], [options] )Shorthand for addListener. ...Shorthand for addListener.
Appends an event handler to this object.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to listen for. May also be an object who's property names are
event names.
- fn : Function
The method the event invokes. Will be called with arguments given to
fireEvent plus the options parameter described below.
- scope : Object (optional)
The scope (this reference) in which the handler function is executed. If
omitted, defaults to the object which fired the event.
- options : Object (optional)
An object containing handler configuration.
Note: Unlike in ExtJS 3.x, the options object will also be passed as the last argument to every event handler.
This object may contain any of the following properties:
scope : Object
The scope (this reference) in which the handler function is executed. If omitted, defaults to the object
which fired the event.
delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
buffer : Number
Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of
milliseconds. If the event fires again within that time, the original handler is not invoked, but the new
handler is scheduled in its place.
target : Observable
Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a
child Observable.
element : String
This option is only valid for listeners bound to Components. The name of a Component
property which references an element to add a listener to.
This option is useful during Component construction to add DOM event listeners to elements of
Components which will exist only after the Component is rendered.
For example, to add a click listener to a Panel's body:
new Ext.panel.Panel({
title: 'The title',
listeners: {
click: this.handlePanelClick,
element: 'body'
}
});
Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener.
myPanel.on('hide', this.handleClick, this, {
single: true,
delay: 100
});
Attaching multiple handlers in 1 call
The method also allows for a single argument to be passed which is a config object containing properties which
specify multiple events. For example:
myGridPanel.on({
cellClick: this.onCellClick,
mouseover: this.onMouseOver,
mouseout: this.onMouseOut,
scope: this // Important. Ensure "this" is correct during handler execution
});
One can also specify options for each event handler separately:
myGridPanel.on({
cellClick: {fn: this.onCellClick, scope: this, single: true},
mouseover: {fn: panel.onMouseOver, scope: panel}
});
processResponse( success, operation, request, response, callback, scope )private read( operation, callback, scope )Performs the given read operation. ...Performs the given read operation.
Available since: 4.0.0
Parameters
- operation : Ext.data.Operation
The Operation to perform
- callback : Function
Callback function to be called when the Operation has completed (whether successful or not)
- scope : Object
Scope to execute the callback function in
Overrides: Ext.data.proxy.Proxy.read
relayEvents( origin, events, prefix )Relays selected events from the specified Observable as if the events were fired by this. ... removeListener( eventName, fn, [scope] )Removes an event handler. ...Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the
addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the
scope argument specified in the original call to addListener or the listener will not be removed.
removeManagedListener( item, ename, [fn], [scope] )Removes listeners that were added by the mon method. ...Removes listeners that were added by the mon method.
Available since: 4.0.0
Parameters
- item : Ext.util.Observable/Ext.Element
The item from which to remove a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the ename parameter was an event name, this is the handler function.
- scope : Object (optional)
If the ename parameter was an event name, this is the scope (this reference)
in which the handler function is executed.
removeManagedListenerItem( isClear, managedListener )private resumeEvents( )Resumes firing events (see suspendEvents). ...Resumes firing events (see suspendEvents).
If events were suspended using the queueSuspended parameter, then all events fired
during event suspension will be sent to any listeners now.
Available since: 2.3.0
setException( operation, response )privateSets up an exception on the operation ...Sets up an exception on the operation
Available since: 4.0.0
Parameters
- operation : Ext.data.Operation
The operation
- response : Object
The response
setModel( model, setOnStore )Sets the model associated with this proxy. ...Sets the model associated with this proxy. This will only usually be called by a Store
Available since: 4.0.0
Parameters
- model : String/Ext.data.Model
The new model. Can be either the model name string,
or a reference to the model's constructor
- setOnStore : Boolean
Sets the new model on the associated Store, if one is present
Sets the Proxy's Reader by string, config object or Reader instance ...Sets the Proxy's Reader by string, config object or Reader instance
Available since: 4.0.0
Parameters
- reader : String/Object/Ext.data.reader.Reader
The new Reader, which can be either a type string,
a configuration object or an Ext.data.reader.Reader instance
Returns
- Ext.data.reader.Reader
The attached Reader object
Sets the Proxy's Writer by string, config object or Writer instance ...Sets the Proxy's Writer by string, config object or Writer instance
Available since: 4.0.0
Parameters
- writer : String/Object/Ext.data.writer.Writer
The new Writer, which can be either a type string,
a configuration object or an Ext.data.writer.Writer instance
Returns
- Ext.data.writer.Writer
The attached Writer object
Get the reference to the class from which this object was instantiated. ...Get the reference to the class from which this object was instantiated. Note that unlike self,
this.statics() is scope-independent and it always returns the class from which it was called, regardless of what
this points to during run-time
Ext.define('My.Cat', {
statics: {
totalCreated: 0,
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
var statics = this.statics();
alert(statics.speciesName); // always equals to 'Cat' no matter what 'this' refers to
// equivalent to: My.Cat.speciesName
alert(this.self.speciesName); // dependent on 'this'
statics.totalCreated++;
return this;
},
clone: function() {
var cloned = new this.self; // dependent on 'this'
cloned.groupName = this.statics().speciesName; // equivalent to: My.Cat.speciesName
return cloned;
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
},
constructor: function() {
this.callParent();
}
});
var cat = new My.Cat(); // alerts 'Cat', then alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Cat', then alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
alert(clone.groupName); // alerts 'Cat'
alert(My.Cat.totalCreated); // alerts 3
Available since: 4.0.0
Returns
suspendEvents( queueSuspended )Suspends the firing of all events. ...Suspends the firing of all events. (see resumeEvents)
Available since: 2.3.0
Parameters
- queueSuspended : Boolean
Pass as true to queue up suspended events to be fired
after the resumeEvents call instead of discarding all suspended events.
un( eventName, fn, [scope] )Shorthand for removeListener. ...Shorthand for removeListener.
Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the
addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the
scope argument specified in the original call to addListener or the listener will not be removed.
update( operation, callback, scope )Performs the given update operation. ...Performs the given update operation.
Available since: 4.0.0
Parameters
- operation : Ext.data.Operation
The Operation to perform
- callback : Function
Callback function to be called when the Operation has completed (whether successful or not)
- scope : Object
Scope to execute the callback function in
Overrides: Ext.data.proxy.Proxy.update
Note that if this HttpProxy is being used by a Store, then the Store's call to load will override any specified callback and params options. In this case, use the Store's events to modify parameters, or react to loading events.
Available since: 1.1.0
Parameters
- config : Object (optional)
Config object. If an options parameter is passed, the singleton Ext.Ajax object will be used to make the request.
Returns
Overrides: Ext.data.proxy.Proxy.constructor
Adds the specified events to the list of events which this Observable may fire.
Available since: 1.1.0
Parameters
- o : Object/String
Either an object with event names as properties with a value of
trueor the first event name string if multiple event names are being passed as separate parameters. Usage:this.addEvents({ storeloaded: true, storecleared: true }); - more : String... (optional)
Additional event names if multiple event names are being passed as separate parameters. Usage:
this.addEvents('storeloaded', 'storecleared');
Appends an event handler to this object.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to listen for. May also be an object who's property names are event names.
- fn : Function
The method the event invokes. Will be called with arguments given to fireEvent plus the
optionsparameter described below. - scope : Object (optional)
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event. - options : Object (optional)
An object containing handler configuration.
Note: Unlike in ExtJS 3.x, the options object will also be passed as the last argument to every event handler.
This object may contain any of the following properties:
scope : Object
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event.delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
buffer : Number
Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
target : Observable
Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.
element : String
This option is only valid for listeners bound to Components. The name of a Component property which references an element to add a listener to.
This option is useful during Component construction to add DOM event listeners to elements of Components which will exist only after the Component is rendered. For example, to add a click listener to a Panel's body:
new Ext.panel.Panel({ title: 'The title', listeners: { click: this.handlePanelClick, element: 'body' } });
Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener.
myPanel.on('hide', this.handleClick, this, { single: true, delay: 100 });Attaching multiple handlers in 1 call
The method also allows for a single argument to be passed which is a config object containing properties which specify multiple events. For example:
myGridPanel.on({ cellClick: this.onCellClick, mouseover: this.onMouseOver, mouseout: this.onMouseOut, scope: this // Important. Ensure "this" is correct during handler execution });One can also specify options for each event handler separately:
myGridPanel.on({ cellClick: {fn: this.onCellClick, scope: this, single: true}, mouseover: {fn: panel.onMouseOver, scope: panel} });
Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is destroyed.
Available since: 4.0.0
Parameters
- item : Ext.util.Observable/Ext.Element
The item to which to add a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
enameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
enameparameter was an event name, this is the scope (thisreference) in which the handler function is executed. - opt : Object (optional)
If the
enameparameter was an event name, this is the addListener options.
Optional callback function which can be used to clean up after a request has been completed.
Available since: 4.0.0
Parameters
- request : Ext.data.Request
The Request object
- success : Boolean
True if the request was successful
Performs a batch of Operations, in the order specified by batchOrder. Used internally by Ext.data.Store's sync method. Example usage:
myProxy.batch({
create : [myModel1, myModel2],
update : [myModel3],
destroy: [myModel4, myModel5]
});
Where the myModel* above are Model instances - in this case 1 and 2 are new instances and have not been saved before, 3 has been saved previously but needs to be updated, and 4 and 5 have already been saved but should now be destroyed.
Available since: 4.0.0
Parameters
- operations : Object
Object containing the Model instances to act upon, keyed by action name
- listeners : Object (optional)
listeners object passed straight through to the Batch - see Ext.data.Batch
Returns
- Ext.data.Batch
The newly created Ext.data.Batch object
Creates and returns an Ext.data.Request object based on the options passed by the Store that this Proxy is attached to.
Available since: 4.0.0
Parameters
- operation : Ext.data.Operation
The Operation object to execute
Returns
- Ext.data.Request
The request object
Specialized version of buildUrl that incorporates the appendId and format options into the generated url. Override this to provide further customizations, but remember to call the superclass buildUrl so that additional parameters like the cache buster string are appended.
Available since: 4.0.0
Parameters
- request : Object
Overrides: Ext.data.proxy.Server.buildUrl
Call the original method that was previously overridden with override
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
return this;
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
var instance = this.callOverridden();
alert("Meeeeoooowwww");
return instance;
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
Available since: 4.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the
argumentsobject
Returns
- Object
Returns the result after calling the overridden method
Call the parent's overridden method. For example:
Ext.define('My.own.A', {
constructor: function(test) {
alert(test);
}
});
Ext.define('My.own.B', {
extend: 'My.own.A',
constructor: function(test) {
alert(test);
this.callParent([test + 1]);
}
});
Ext.define('My.own.C', {
extend: 'My.own.B',
constructor: function() {
alert("Going to call parent's overriden constructor...");
this.callParent(arguments);
}
});
var a = new My.own.A(1); // alerts '1'
var b = new My.own.B(1); // alerts '1', then alerts '2'
var c = new My.own.C(2); // alerts "Going to call parent's overriden constructor..."
// alerts '2', then alerts '3'
Available since: 4.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the
argumentsobject from the current method, for example:this.callParent(arguments)
Returns
- Object
Returns the result from the superclass' method
Removes all listeners for this object including the managed listeners
Available since: 4.0.0
Removes all managed listeners for this object.
Available since: 4.0.0
in a ServerProxy all four CRUD operations are executed in the same manner, so we delegate to doRequest in each case
Performs the given create operation.
Available since: 4.0.0
Parameters
- operation : Ext.data.Operation
The Operation to perform
- callback : Function
Callback function to be called when the Operation has completed (whether successful or not)
- scope : Object
Scope to execute the callback function in
Overrides: Ext.data.proxy.Proxy.create
TODO: This is currently identical to the JsonPProxy version except for the return function's signature. There is a lot of code duplication inside the returned function so we need to find a way to DRY this up.
Available since: 4.0.0
Parameters
- request : Ext.data.Request
The Request object
- operation : Ext.data.Operation
The Operation being executed
- callback : Function
The callback function to be called when the request completes. This is usually the callback passed to doRequest
- scope : Object
The scope in which to execute the callback function
Returns
- Function
The callback function
Performs the given destroy operation.
Available since: 4.0.0
Parameters
- operation : Ext.data.Operation
The Operation to perform
- callback : Function
Callback function to be called when the Operation has completed (whether successful or not)
- scope : Object
Scope to execute the callback function in
Overrides: Ext.data.proxy.Proxy.destroy
In ServerProxy subclasses, the create, read, update and destroy methods all pass through to doRequest. Each ServerProxy subclass must implement the doRequest method - see Ext.data.proxy.JsonP and Ext.data.proxy.Ajax for examples. This method carries the same signature as each of the methods that delegate to it.
Available since: 4.0.0
Parameters
- operation : Ext.data.Operation
The Ext.data.Operation object
- callback : Function
The callback function to call when the Operation has completed
- scope : Object
The scope in which to execute the callback
Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if
present. There is no implementation in the Observable base class.
This is commonly used by Ext.Components to bubble events to owner Containers. See Ext.Component.getBubbleTarget. The default implementation in Ext.Component returns the Component's immediate owner. But if a known target is required, this can be overridden to access the required target more quickly.
Example:
Ext.override(Ext.form.field.Base, {
// Add functionality to Field's initComponent to enable the change event to bubble
initComponent : Ext.Function.createSequence(Ext.form.field.Base.prototype.initComponent, function() {
this.enableBubble('change');
}),
// We know that we want Field's events to bubble directly to the FormPanel.
getBubbleTarget : function() {
if (!this.formPanel) {
this.formPanel = this.findParentByType('form');
}
return this.formPanel;
}
});
var myForm = new Ext.formPanel({
title: 'User Details',
items: [{
...
}],
listeners: {
change: function() {
// Title goes red if form has been modified.
myForm.header.setStyle('color', 'red');
}
}
});
Available since: 3.4.0
Parameters
Encodes the array of Ext.util.Filter objects into a string to be sent in the request url. By default, this simply JSON-encodes the filter data
Available since: 4.0.0
Parameters
- filters : Ext.util.Filter[]
The array of Filter objects
Returns
- String
The encoded filters
Encodes the array of Ext.util.Sorter objects into a string to be sent in the request url. By default, this simply JSON-encodes the sorter data
Available since: 4.0.0
Parameters
- sorters : Ext.util.Sorter[]
The array of Sorter objects
Returns
- String
The encoded sorters
Template method to allow subclasses to specify how to get the response for the reader.
Available since: 4.0.0
This is a template method. a hook into the functionality of this class. Feel free to override it in child classes.
Parameters
- response : Object
The server response
Returns
- Object
The response data to be used by the reader
Fires the specified event with the passed parameters (minus the event name, plus the options object passed
to addListener).
An event may be set to bubble up an Observable parent hierarchy (See Ext.Component.getBubbleTarget) by calling enableBubble.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to fire.
- args : Object...
Variable number of parameters are passed to handlers.
Returns
- Boolean
returns false if any of the handlers return false otherwise it returns true.
Gets the bubbling parent for an Observable
Available since: Ext JS 4.0.7
Returns
- Ext.util.Observable
The bubble parent. null is returned if no bubble target exists
Returns the HTTP method name for a given request. By default this returns based on a lookup on actionMethods.
Available since: 4.0.0
Parameters
- request : Ext.data.Request
The request object
Returns
- String
The HTTP method to use (should be one of 'GET', 'POST', 'PUT' or 'DELETE')
Copy any sorters, filters etc into the params so they can be sent over the wire
Available since: 4.0.0
Parameters
- operation : Object
Returns the reader currently attached to this proxy instance
Available since: 4.0.0
Returns
- Ext.data.reader.Reader
The Reader instance
Get the url for the request taking into account the order of priority, - The request - The api - The url
Available since: 4.0.0
Parameters
- request : Ext.data.Request
The request
Returns
- String
The url
Returns the writer currently attached to this proxy instance
Available since: 4.0.0
Returns
- Ext.data.writer.Writer
The Writer instance
Initialize configuration for this class. a typical example:
Ext.define('My.awesome.Class', {
// The default config
config: {
name: 'Awesome',
isAwesome: true
},
constructor: function(config) {
this.initConfig(config);
return this;
}
});
var awesome = new My.awesome.Class({
name: 'Super Awesome'
});
alert(awesome.getName()); // 'Super Awesome'
Available since: 4.0.0
Parameters
- config : Object
Returns
- Object
mixins The mixin prototypes as key - value pairs
Shorthand for addManagedListener.
Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is destroyed.
Available since: 4.0.2
Parameters
- item : Ext.util.Observable/Ext.Element
The item to which to add a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
enameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
enameparameter was an event name, this is the scope (thisreference) in which the handler function is executed. - opt : Object (optional)
If the
enameparameter was an event name, this is the addListener options.
Shorthand for removeManagedListener.
Removes listeners that were added by the mon method.
Available since: 4.0.2
Parameters
- item : Ext.util.Observable/Ext.Element
The item from which to remove a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
enameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
enameparameter was an event name, this is the scope (thisreference) in which the handler function is executed.
Shorthand for addListener.
Appends an event handler to this object.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to listen for. May also be an object who's property names are event names.
- fn : Function
The method the event invokes. Will be called with arguments given to fireEvent plus the
optionsparameter described below. - scope : Object (optional)
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event. - options : Object (optional)
An object containing handler configuration.
Note: Unlike in ExtJS 3.x, the options object will also be passed as the last argument to every event handler.
This object may contain any of the following properties:
scope : Object
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event.delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
buffer : Number
Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
target : Observable
Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.
element : String
This option is only valid for listeners bound to Components. The name of a Component property which references an element to add a listener to.
This option is useful during Component construction to add DOM event listeners to elements of Components which will exist only after the Component is rendered. For example, to add a click listener to a Panel's body:
new Ext.panel.Panel({ title: 'The title', listeners: { click: this.handlePanelClick, element: 'body' } });
Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener.
myPanel.on('hide', this.handleClick, this, { single: true, delay: 100 });Attaching multiple handlers in 1 call
The method also allows for a single argument to be passed which is a config object containing properties which specify multiple events. For example:
myGridPanel.on({ cellClick: this.onCellClick, mouseover: this.onMouseOver, mouseout: this.onMouseOut, scope: this // Important. Ensure "this" is correct during handler execution });One can also specify options for each event handler separately:
myGridPanel.on({ cellClick: {fn: this.onCellClick, scope: this, single: true}, mouseover: {fn: panel.onMouseOver, scope: panel} });
Performs the given read operation.
Available since: 4.0.0
Parameters
- operation : Ext.data.Operation
The Operation to perform
- callback : Function
Callback function to be called when the Operation has completed (whether successful or not)
- scope : Object
Scope to execute the callback function in
Overrides: Ext.data.proxy.Proxy.read
Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the scope argument specified in the original call to addListener or the listener will not be removed.
Removes listeners that were added by the mon method.
Available since: 4.0.0
Parameters
- item : Ext.util.Observable/Ext.Element
The item from which to remove a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
enameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
enameparameter was an event name, this is the scope (thisreference) in which the handler function is executed.
Resumes firing events (see suspendEvents).
If events were suspended using the queueSuspended parameter, then all events fired
during event suspension will be sent to any listeners now.
Available since: 2.3.0
Sets up an exception on the operation
Available since: 4.0.0
Parameters
- operation : Ext.data.Operation
The operation
- response : Object
The response
Sets the model associated with this proxy. This will only usually be called by a Store
Available since: 4.0.0
Parameters
- model : String/Ext.data.Model
The new model. Can be either the model name string, or a reference to the model's constructor
- setOnStore : Boolean
Sets the new model on the associated Store, if one is present
Sets the Proxy's Reader by string, config object or Reader instance
Available since: 4.0.0
Parameters
- reader : String/Object/Ext.data.reader.Reader
The new Reader, which can be either a type string, a configuration object or an Ext.data.reader.Reader instance
Returns
- Ext.data.reader.Reader
The attached Reader object
Sets the Proxy's Writer by string, config object or Writer instance
Available since: 4.0.0
Parameters
- writer : String/Object/Ext.data.writer.Writer
The new Writer, which can be either a type string, a configuration object or an Ext.data.writer.Writer instance
Returns
- Ext.data.writer.Writer
The attached Writer object
Get the reference to the class from which this object was instantiated. Note that unlike self,
this.statics() is scope-independent and it always returns the class from which it was called, regardless of what
this points to during run-time
Ext.define('My.Cat', {
statics: {
totalCreated: 0,
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
var statics = this.statics();
alert(statics.speciesName); // always equals to 'Cat' no matter what 'this' refers to
// equivalent to: My.Cat.speciesName
alert(this.self.speciesName); // dependent on 'this'
statics.totalCreated++;
return this;
},
clone: function() {
var cloned = new this.self; // dependent on 'this'
cloned.groupName = this.statics().speciesName; // equivalent to: My.Cat.speciesName
return cloned;
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
},
constructor: function() {
this.callParent();
}
});
var cat = new My.Cat(); // alerts 'Cat', then alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Cat', then alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
alert(clone.groupName); // alerts 'Cat'
alert(My.Cat.totalCreated); // alerts 3
Available since: 4.0.0
Returns
Suspends the firing of all events. (see resumeEvents)
Available since: 2.3.0
Parameters
- queueSuspended : Boolean
Pass as true to queue up suspended events to be fired after the resumeEvents call instead of discarding all suspended events.
Shorthand for removeListener.
Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the scope argument specified in the original call to addListener or the listener will not be removed.
Performs the given update operation.
Available since: 4.0.0
Parameters
- operation : Ext.data.Operation
The Operation to perform
- callback : Function
Callback function to be called when the Operation has completed (whether successful or not)
- scope : Object
Scope to execute the callback function in
Overrides: Ext.data.proxy.Proxy.update
Static Methods Add / override static properties of this class. ...Add / override static properties of this class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.addStatics({
someProperty: 'someValue', // My.cool.Class.someProperty = 'someValue'
method1: function() { ... }, // My.cool.Class.method1 = function() { ... };
method2: function() { ... } // My.cool.Class.method2 = function() { ... };
});
Available since: 4.0.2
Parameters
- members : Object
Returns
- Ext.Base
this
Borrow another class' members to the prototype of this class. ...Borrow another class' members to the prototype of this class.
Ext.define('Bank', {
money: '$$$',
printMoney: function() {
alert('$$$$$$$');
}
});
Ext.define('Thief', {
...
});
Thief.borrow(Bank, ['money', 'printMoney']);
var steve = new Thief();
alert(steve.money); // alerts '$$$'
steve.printMoney(); // alerts '$$$$$$$'
Available since: 4.0.2
Parameters
- fromClass : Ext.Base
The class to borrow members from
- members : String/String[]
The names of the members to borrow
Returns
- Ext.Base
this
Create a new instance of this Class. ...Create a new instance of this Class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.create({
someConfig: true
});
All parameters are passed to the constructor of the class.
Available since: 4.0.2
Returns
- Object
the created instance.
createAlias( alias, origin )staticCreate aliases for existing prototype methods. ...Create aliases for existing prototype methods. Example:
Ext.define('My.cool.Class', {
method1: function() { ... },
method2: function() { ... }
});
var test = new My.cool.Class();
My.cool.Class.createAlias({
method3: 'method1',
method4: 'method2'
});
test.method3(); // test.method1()
My.cool.Class.createAlias('method5', 'method3');
test.method5(); // test.method3() -> test.method1()
Available since: 4.0.2
Parameters
- alias : String/Object
The new method name, or an object to set multiple aliases. See
flexSetter
- origin : String/Object
The original method name
Get the current class' name in string format. ...Get the current class' name in string format.
Ext.define('My.cool.Class', {
constructor: function() {
alert(this.self.getName()); // alerts 'My.cool.Class'
}
});
My.cool.Class.getName(); // 'My.cool.Class'
Available since: 4.0.4
Returns
- String
className
implement( members )staticAdd methods / properties to the prototype of this class. ...Add methods / properties to the prototype of this class.
Ext.define('My.awesome.Cat', {
constructor: function() {
...
}
});
My.awesome.Cat.implement({
meow: function() {
alert('Meowww...');
}
});
var kitty = new My.awesome.Cat;
kitty.meow();
Available since: 4.0.2
Parameters
- members : Object
Override prototype members of this class. ...Override prototype members of this class. Overridden methods can be invoked via
callOverridden
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
return this;
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
var instance = this.callOverridden();
alert("Meeeeoooowwww");
return instance;
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
Available since: 4.0.2
Parameters
- members : Object
Returns
- Ext.Base
this
Add / override static properties of this class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.addStatics({
someProperty: 'someValue', // My.cool.Class.someProperty = 'someValue'
method1: function() { ... }, // My.cool.Class.method1 = function() { ... };
method2: function() { ... } // My.cool.Class.method2 = function() { ... };
});
Available since: 4.0.2
Parameters
- members : Object
Returns
- Ext.Base
this
Borrow another class' members to the prototype of this class.
Ext.define('Bank', {
money: '$$$',
printMoney: function() {
alert('$$$$$$$');
}
});
Ext.define('Thief', {
...
});
Thief.borrow(Bank, ['money', 'printMoney']);
var steve = new Thief();
alert(steve.money); // alerts '$$$'
steve.printMoney(); // alerts '$$$$$$$'
Available since: 4.0.2
Parameters
- fromClass : Ext.Base
The class to borrow members from
- members : String/String[]
The names of the members to borrow
Returns
- Ext.Base
this
Create a new instance of this Class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.create({
someConfig: true
});
All parameters are passed to the constructor of the class.
Available since: 4.0.2
Returns
- Object
the created instance.
Create aliases for existing prototype methods. Example:
Ext.define('My.cool.Class', {
method1: function() { ... },
method2: function() { ... }
});
var test = new My.cool.Class();
My.cool.Class.createAlias({
method3: 'method1',
method4: 'method2'
});
test.method3(); // test.method1()
My.cool.Class.createAlias('method5', 'method3');
test.method5(); // test.method3() -> test.method1()
Available since: 4.0.2
Parameters
- alias : String/Object
The new method name, or an object to set multiple aliases. See flexSetter
- origin : String/Object
The original method name
Get the current class' name in string format.
Ext.define('My.cool.Class', {
constructor: function() {
alert(this.self.getName()); // alerts 'My.cool.Class'
}
});
My.cool.Class.getName(); // 'My.cool.Class'
Available since: 4.0.4
Returns
- String
className
Add methods / properties to the prototype of this class.
Ext.define('My.awesome.Cat', {
constructor: function() {
...
}
});
My.awesome.Cat.implement({
meow: function() {
alert('Meowww...');
}
});
var kitty = new My.awesome.Cat;
kitty.meow();
Available since: 4.0.2
Parameters
- members : Object
Override prototype members of this class. Overridden methods can be invoked via callOverridden
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
return this;
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
var instance = this.callOverridden();
alert("Meeeeoooowwww");
return instance;
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
Available since: 4.0.2
Parameters
- members : Object
Returns
- Ext.Base
this
Events
Fires when the server returns an exception
Available since: 4.0.0
Parameters
- this : Ext.data.proxy.Proxy
- response : Object
The response from the AJAX request
- operation : Ext.data.Operation
The operation that triggered request
- eOpts : Object
The options object passed to Ext.util.Observable.addListener.